
//
//  PHAlertView.m
//  KCWallet
//
//  Created by penguin on 2018/4/19.
//  Copyright © 2018年 penguin. All rights reserved.
//

///alertView  宽
#define AlertW 280
///各个栏目之间的距离
#define XLSpace 10.0

#define COLORRGB(r,g,b) [UIColor colorWithRed:r/255.f green:g/255.f blue:b/255.f alpha:1]
#define COLORGRAY(f) COLORRGB(f,f,f)
#define COLOR_BLUE  COLORRGB(0,170,227)
#define COLOR_LINE_GRAY  COLORGRAY(240)
#define COLOR_BACK_GRAY  COLORGRAY(230)

#import "UIView+Extension.h"

#import "UIImageView+Extension.h"

#import "PHAlertView.h"

@interface PHAlertView()
//弹窗
@property (nonatomic,retain) UIView *alertView;
//title
@property (nonatomic,retain) UILabel *titleLbl;
//内容
@property (nonatomic,retain) UILabel *msgLbl;
//确认按钮
@property (nonatomic,retain) UIButton *sureBtn;
//取消按钮
@property (nonatomic,retain) UIButton *cancleBtn;
//横线线
@property (nonatomic,retain) UIView *lineView;
//竖线
@property (nonatomic,retain) UIView *verLineView;
//输入框
@property(nonatomic,strong)UITextField * textField;
//输入框目前字符串
@property (nonatomic, copy)NSString * inputStr;
//提示图片
@property(nonatomic,strong)UIImageView * imaView;


@end

@implementation PHAlertView


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

+(PHAlertView *)contentView{
    PHAlertView * phAlert = [[PHAlertView alloc]init];
    phAlert.frame = [UIScreen mainScreen].bounds;
    phAlert.backgroundColor =  [[UIColor blackColor] colorWithAlphaComponent:0.5];
    phAlert.alertView = [[UIView alloc] init];
    phAlert.alertView.backgroundColor = [UIColor whiteColor];
    phAlert.alertView.layer.cornerRadius = 8.0;
    phAlert.alertView.frame = CGRectZero;
    phAlert.alertView.layer.position = phAlert.center;
    [phAlert addSubview:phAlert.alertView];
    [phAlert showXLAlertView];
    return phAlert;
}
#pragma mark 纯文本提示带按钮
+(instancetype)showTitle:(NSString *)title message:(NSString *)message surnBtnTitle:(NSString *)sureTitle result:(AlertResult)result{
    PHAlertView * phAlert = [PHAlertView contentView];
    if (title) {
        phAlert.titleLbl = [phAlert GetAdaptiveLable:CGRectMake(2*XLSpace, 2*XLSpace, AlertW-4*XLSpace, 20) AndText:title andIsTitle:YES];
        phAlert.titleLbl.textAlignment = NSTextAlignmentCenter;
        [phAlert.alertView addSubview:phAlert.titleLbl];
        CGFloat titleW = phAlert.titleLbl.bounds.size.width;
        CGFloat titleH = phAlert.titleLbl.bounds.size.height;
        phAlert.titleLbl.frame = CGRectMake((AlertW-titleW)/2, 2*XLSpace, titleW, titleH);
    }
    if (message) {
        phAlert.msgLbl = [phAlert GetAdaptiveLable:CGRectMake(XLSpace, CGRectGetMaxY(phAlert.titleLbl.frame)+XLSpace, AlertW-2*XLSpace, 20) AndText:message andIsTitle:NO];
        phAlert.msgLbl.textAlignment = NSTextAlignmentCenter;
        [phAlert.alertView addSubview:phAlert.msgLbl];
        
        CGFloat msgW = phAlert.msgLbl.bounds.size.width;
        CGFloat msgH = phAlert.msgLbl.bounds.size.height;
        
        phAlert.msgLbl.frame = phAlert.titleLbl?CGRectMake((AlertW-msgW)/2, CGRectGetMaxY(phAlert.titleLbl.frame)+XLSpace, msgW, msgH):CGRectMake((AlertW-msgW)/2, 2*XLSpace, msgW, msgH);
        phAlert.msgLbl.textColor = [UIColor lightGrayColor];
    }
    phAlert.lineView = [UIView viewWithFrame:phAlert.msgLbl?CGRectMake(0, CGRectGetMaxY(phAlert.msgLbl.frame)+2*XLSpace, AlertW, 1):CGRectMake(0, CGRectGetMaxY(phAlert.titleLbl.frame)+2*XLSpace, AlertW, 1) backColor:COLOR_LINE_GRAY];
    [phAlert.alertView addSubview:phAlert.lineView];
    //按钮
    NSString * sureTitleStr;
    if (sureTitle == nil) {
        sureTitleStr = @"知道了";
    }else{
        sureTitleStr = sureTitle;
    }
    phAlert.sureBtn = [phAlert createFrame:CGRectMake(0, CGRectGetMaxY(phAlert.lineView.frame), AlertW, 40) tag:2 title:sureTitleStr action:@selector(buttonEvent:)];
    [phAlert.alertView addSubview:phAlert.sureBtn];
    
    //计算高度
    CGFloat alertHeight = CGRectGetMaxY(phAlert.sureBtn.frame);
    phAlert.alertView.frame = CGRectMake(0, 0, AlertW, alertHeight);
    phAlert.alertView.layer.position = phAlert.center;
    phAlert.resultIndex = result;
    return phAlert;
}
#pragma mark 带有输入框的提示
+(instancetype)showTitle:(NSString *)title inputTitle:(NSString *)inputTitle surnBtnTitle:(NSString *)sureTitle cancelBtn:(NSString *)cancelTitle input:(AlertInputResult)input{
    PHAlertView * phAlert = [PHAlertView contentView];
    if (title) {
        phAlert.titleLbl = [phAlert GetAdaptiveLable:CGRectMake(2*XLSpace, 2*XLSpace, AlertW-4*XLSpace, 20) AndText:title andIsTitle:YES];
        phAlert.titleLbl.textAlignment = NSTextAlignmentCenter;
        [phAlert.alertView addSubview:phAlert.titleLbl];
        CGFloat titleW = phAlert.titleLbl.bounds.size.width;
        CGFloat titleH = phAlert.titleLbl.bounds.size.height;
        phAlert.titleLbl.frame = CGRectMake((AlertW-titleW)/2, 2*XLSpace, titleW, titleH);
    }
    if (inputTitle) {
        phAlert.msgLbl = [phAlert GetAdaptiveLable:CGRectMake(XLSpace, CGRectGetMaxY(phAlert.titleLbl.frame)+XLSpace, AlertW-2*XLSpace, 20) AndText:inputTitle andIsTitle:NO];
        phAlert.msgLbl.textAlignment = NSTextAlignmentLeft;
        phAlert.msgLbl.textColor = [UIColor lightGrayColor];
        [phAlert.alertView addSubview:phAlert.msgLbl];
        //密码输入相关
        phAlert.textField = [[UITextField alloc]initWithFrame:CGRectMake(XLSpace, CGRectGetMaxY(phAlert.msgLbl.frame), AlertW-2*XLSpace, 40)];
        [phAlert.textField addTarget:phAlert action:@selector(textFieldChange:) forControlEvents:UIControlEventEditingChanged];
        phAlert.textField.font = [UIFont systemFontOfSize:15];
        phAlert.textField.placeholder = inputTitle;
        phAlert.textField.secureTextEntry = YES;
        [phAlert.alertView addSubview:phAlert.textField];
    }
    phAlert.lineView = [UIView viewWithFrame:phAlert.textField?CGRectMake(XLSpace, CGRectGetMaxY(phAlert.textField.frame), AlertW-2*XLSpace, 1.8):CGRectMake(0, CGRectGetMaxY(phAlert.titleLbl.frame), AlertW-2*XLSpace, 1.8) backColor:COLOR_BLUE];
    [phAlert.alertView addSubview:phAlert.lineView];
    //两个按钮
    if (sureTitle && cancelTitle) {
        phAlert.cancleBtn = [phAlert createFrame:CGRectMake(0, CGRectGetMaxY(phAlert.lineView.frame), AlertW/2, 50) tag:1 title:cancelTitle action:@selector(buttonEventInput:)];
        [phAlert.cancleBtn setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
        [phAlert.alertView addSubview:phAlert.cancleBtn];
        
        phAlert.sureBtn = [phAlert createFrame:CGRectMake(AlertW/2, CGRectGetMaxY(phAlert.lineView.frame), AlertW/2, 50) tag:2 title:sureTitle action:@selector(buttonEventInput:)];
        [phAlert.alertView addSubview:phAlert.sureBtn];
    }
    //计算高度
    CGFloat alertHeight = CGRectGetMaxY(phAlert.sureBtn.frame);
    phAlert.alertView.frame = CGRectMake(0, 0, AlertW, alertHeight);
    phAlert.alertView.layer.position = phAlert.center;
    phAlert.resuleInput = input;
    return phAlert;
}
#pragma mark单图片单文本提示框
+(instancetype)showTitle:(NSString *)title picType:(AlertPicType)type{
    PHAlertView * phAlert = [PHAlertView contentView];
    phAlert.imaView = [UIImageView imageViewFrame:CGRectMake((AlertW - 50)/2, 40, 50, 50) imgName:@"succes"];
    [phAlert.alertView addSubview:phAlert.imaView];
    phAlert.titleLbl =[phAlert GetAdaptiveLable:CGRectZero AndText:title andIsTitle:YES];
    [phAlert.alertView addSubview:phAlert.titleLbl];
    
    CGFloat titleW = phAlert.titleLbl.bounds.size.width;
    CGFloat titleH = phAlert.titleLbl.bounds.size.height;
    phAlert.titleLbl.frame = CGRectMake((AlertW-titleW)/2,CGRectGetMaxY(phAlert.imaView.frame) +  2*XLSpace, titleW, titleH);
    
    CGFloat alertHeight = CGRectGetMaxY(phAlert.titleLbl.frame) + 40;
    phAlert.alertView.frame = CGRectMake(0, 0, AlertW, alertHeight);
    phAlert.alertView.layer.position = phAlert.center;
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.6 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [phAlert removeFromSuperview];
    });
    return phAlert;
}
#pragma mark 输入框
-(void)textFieldChange:(UITextField *)tf{
    self.inputStr = tf.text;
}
-(void)buttonEventInput:(UIButton *)btn{
    NSLog(@"buttonEventInput");
    if (btn.tag == 1) {
       
    }else{
        if (self.resuleInput) {
            self.resuleInput(self.inputStr);
        }
    }
    [self removeFromSuperview];
    
}
- (void)buttonEvent:(UIButton *)sender
{
     NSLog(@"buttonEvent");
    if (self.resultIndex) {
        self.resultIndex(sender.tag);
    }
    [self removeFromSuperview];
}
#pragma mark - 弹出 -
- (void)showXLAlertView
{
    UIWindow *rootWindow = [UIApplication sharedApplication].keyWindow;
    [rootWindow addSubview:self];
    [self creatShowAnimation];
}

- (void)creatShowAnimation
{
    self.alertView.layer.position = self.center;
    self.alertView.transform = CGAffineTransformMakeScale(0.90, 0.90);
    [UIView animateWithDuration:0.25 delay:0 usingSpringWithDamping:0.8 initialSpringVelocity:1 options:UIViewAnimationOptionCurveLinear animations:^{
        self.alertView.transform = CGAffineTransformMakeScale(1.0, 1.0);
    } completion:^(BOOL finished) {
    }];
}
#pragma mark 封装共有方法
-(UIButton *)createFrame:(CGRect)frame tag:(NSInteger)tag title:(NSString *)title action:(SEL)action{
    UIButton * btn = [UIButton buttonWithType:UIButtonTypeSystem];
    btn.frame = frame;
    [btn setBackgroundImage:[self imageWithColor:[UIColor colorWithRed:255/255.0 green:255/255.0 blue:255/255.0 alpha:0.2]] forState:UIControlStateNormal];
    [btn setBackgroundImage:[self imageWithColor:[UIColor colorWithRed:255/255.0 green:255/255.0 blue:255/255.0 alpha:0.2]] forState:UIControlStateSelected];
    [btn setTitle:title forState:UIControlStateNormal];
    btn.tag = tag;
    [btn addTarget:self action:action forControlEvents:UIControlEventTouchUpInside];
    
    UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:btn.bounds byRoundingCorners:UIRectCornerBottomLeft cornerRadii:CGSizeMake(5.0, 5.0)];
    CAShapeLayer *maskLayer = [[CAShapeLayer alloc] init];
    maskLayer.frame = btn.bounds;
    maskLayer.path = maskPath.CGPath;
    btn.layer.mask = maskLayer;
    return btn;
}
-(UILabel *)GetAdaptiveLable:(CGRect)rect AndText:(NSString *)contentStr andIsTitle:(BOOL)isTitle
{
    UILabel *contentLbl = [[UILabel alloc] initWithFrame:rect];
    contentLbl.numberOfLines = 0;
    contentLbl.text = contentStr;
    contentLbl.textAlignment = NSTextAlignmentCenter;
    if (isTitle) {
        contentLbl.font = [UIFont boldSystemFontOfSize:16.0];
    }else{
        contentLbl.font = [UIFont systemFontOfSize:14.0];
    }
    
    NSMutableAttributedString *mAttrStr = [[NSMutableAttributedString alloc] initWithString:contentStr];
    NSMutableParagraphStyle *mParaStyle = [[NSMutableParagraphStyle alloc] init];
    mParaStyle.lineBreakMode = NSLineBreakByCharWrapping;
    [mParaStyle setLineSpacing:3.0];
    [mAttrStr addAttribute:NSParagraphStyleAttributeName value:mParaStyle range:NSMakeRange(0,[contentStr length])];
    [contentLbl setAttributedText:mAttrStr];
    [contentLbl sizeToFit];
    
    return contentLbl;
}

-(UIImage *)imageWithColor:(UIColor *)color
{
    CGRect rect = CGRectMake(0.0f, 0.0f, 1.0f, 1.0f);
    UIGraphicsBeginImageContext(rect.size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetFillColorWithColor(context, [color CGColor]);
    CGContextFillRect(context, rect);
    UIImage *theImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return theImage;
}
@end
